﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace dds_dxt_mi1
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("DDS to DXT1 conversion for Monkey Island 1 SE v0.1");

            // vstupní soubory
            string filenamedds = "layer0_chunk_0_0.dds";

            int argc = args.Length;
            if (argc > 0)
            {
                filenamedds = args[0];
            }

            Console.WriteLine("\nInput file:\t"+ filenamedds);


            // zkusíme načíst vstup
            byte[] buffdds = null;
            const int off = 128;    // začátek dat v DDS

            try
            {
                buffdds = File.ReadAllBytes(filenamedds);
            }
            catch (IOException e)
            {
                Console.WriteLine(e.Message + "\nCannot open file.");
            }

            if (buffdds != null)
            {
                Console.WriteLine("\t\tLoaded.");

                // kontrola hlavičky "DDS "
                if (buffdds[0] != 'D' || buffdds[1] != 'D' || buffdds[2] != 'S' || buffdds[3] != ' ')
                {
                    // hlavička je špatně
                    Console.WriteLine("\t\tIncorrect header - exiting.");

                }
                else
                {
                    // hlavička je ok
                    Console.WriteLine("\t\tHeader is OK.");

                    // výstupní buffer
                    int datalen = buffdds.Length - off;
                    byte[] buffdxt = new byte[12 + datalen];

                    // potřebuju do výstupu zkopírovat rozměry a FOURCC čili "DXTx"
                    int pos = 0;
                    // FOURCC
                    buffdxt[pos++] = buffdds[84];
                    buffdxt[pos++] = buffdds[85];
                    buffdxt[pos++] = buffdds[86];
                    buffdxt[pos++] = buffdds[87];

                    // width
                    buffdxt[pos++] = buffdds[16];
                    buffdxt[pos++] = buffdds[17];
                    buffdxt[pos++] = buffdds[18];
                    buffdxt[pos++] = buffdds[19];

                    // Height
                    buffdxt[pos++] = buffdds[12];
                    buffdxt[pos++] = buffdds[13];
                    buffdxt[pos++] = buffdds[14];
                    buffdxt[pos++] = buffdds[15];

                    // samotná data by se prý měla jen zkopírovat...?
                    int i = 0;
                    while (i < datalen)
                    {
                        buffdxt[pos+i] = buffdds[off+i];
                        i++;
                    }

                    // nové jméno výstupního souboru
                    string filenamedxt = filenamedds.ToLower();
                    filenamedxt = filenamedxt.Replace(".dds", ".dxt");
                    Console.WriteLine("\nOutput file:\t" + filenamedxt);


                    // uložení do souboru
                    try
                    {
                        File.WriteAllBytes(filenamedxt, buffdxt);
                    }
                    catch (IOException e)
                    {
                        Console.WriteLine(e.Message + "\nCannot save file.");
                    }
                }

            }

            Console.WriteLine("\nDone.");
#if DEBUG
            Console.ReadKey();
#endif

            /*
        SourceFile:= TFileStream.Create(FileName, fmOpenRead);
            try
    //Sanity check first
    SourceFile.Read(Temp, 4);
            if Temp <> 542327876 then //'DDS '
              exit;

            SourceFile.Position := 12;
            SourceFile.Read(Height, 4);
            SourceFile.Read(Width, 4);
            SourceFile.Position := 84; //FOURCC
            SourceFile.Read(Temp, 4); // Store the FOURCC for later
            SourceFile.Position := 128; //End of the dds header

        NewDestDir:= IncludeTrailingPathDelimiter(DestDir) + ExtractPartialPath(FileName, SourceDir);
            ForceDirectories(NewDestDir);

        DestFile:= TFileStream.Create(
                     IncludeTrailingPathDelimiter(NewDestDir) +
                     ChangeFileExt(ExtractFileName(FileName), '.dxt'),
                     fmCreate);
            try
      DestFile.Write(Temp, SizeOf(Temp)); //FOURCC eg DXT5
        Temp:= Width;
            DestFile.Write(Temp, SizeOf(Temp));
        Temp:= Height;
            DestFile.Write(Temp, SizeOf(Temp));

            //Copy over the data
            DestFile.CopyFrom(SourceFile, SourceFile.Size - SourceFile.Position);

            if DestFile.Size > 12 then result := true;
    finally
      DestFile.Free;
            }

  finally
    SourceFile.Free;
            */
        }
    }
}
