/*

// radiogroupPlatformSelect = ??? Button nen viditeln!
   A aplikace mi nikdy nedala na vbr.

    Items.Strings = (
      'Pc'
      'Xbox 360')

    case radiogroupPlatformSelect.ItemIndex of
      0:  IsBigEndian := false;
      1:  IsBigEndian := true;
      else
          IsBigEndian := false;
    end;

// radiogroupGameSelect = MI1 ebo MI2

      case radiogroupGameSelect.ItemIndex of
        0:  RepackMonkey1(FileList.Names[i], FileList.ValueFromIndex[i], EditPath.Text, IsBigEndian);
        1:  RepackMonkey2(FileList.Names[i], FileList.ValueFromIndex[i] ,EditPath.Text, IsBigEndian);
      end;
*/


// MONKEY1

function TfrmMain.RepackMonkey1(FileName, SourceDir, DestDir: string; BigEndian: boolean = false): boolean;
var
  Width, Height: integer;
  Temp: DWord;
  SourceFile, DestFile: TFileStream;
  NewDestDir: string;
{
  Result := false;

  SourceFile := TFileStream.Create(FileName, fmOpenRead);
  try
    //Sanity check first
    SourceFile.Read(Temp, 4);
    if Temp <> 542327876 then //'DDS '
      exit;

    SourceFile.Position := 12;
    SourceFile.Read(Height, 4);
    SourceFile.Read(Width, 4);
    SourceFile.Position := 84; //FOURCC
    SourceFile.Read(Temp, 4); // Store the FOURCC for later
    SourceFile.Position := 128; //End of the dds header

    //Correct for big endian
    if BigEndian then Width := SwapEndianDWord(Width);
    if BigEndian then Height := SwapEndianDWord(Height);

    NewDestDir :=  IncludeTrailingPathDelimiter(DestDir) + ExtractPartialPath( FileName, SourceDir);
    ForceDirectories( NewDestDir );

    DestFile := TFileStream.Create(
                  IncludeTrailingPathDelimiter(NewDestDir) +
                  ChangeFileExt( ExtractFileName( FileName ), '.dxt') ,
                  fmCreate);
    try
      DestFile.Write(Temp, SizeOf(Temp)); //FOURCC eg DXT5
      Temp := Width;
      DestFile.Write(Temp, SizeOf(Temp));
      Temp := Height;
      DestFile.Write(Temp, SizeOf(Temp));

      //Copy over the data
      DestFile.CopyFrom(SourceFile, SourceFile.Size - SourceFile.Position);

      if DestFile.Size > 12 then result := true;
    finally
      DestFile.Free;
    }

  finally
    SourceFile.Free;
  }
}


// MONKEY2

function TfrmMain.RepackMonkey2(FileName, SourceDir, DestDir: string; BigEndian: boolean = false): boolean;
var
  Width, Height: integer;
  Temp: DWord;
  SourceFile, DestFile: TFileStream;
  NewDestDir: string;
{
  Result := false;

  SourceFile := TFileStream.Create(FileName, fmOpenRead);
  try
    //Sanity check first
    SourceFile.Read(Temp, 4);
    if Temp <> 542327876 then //'DDS '
      exit;

    SourceFile.Position := 12;
    SourceFile.Read(Height, 4);
    SourceFile.Read(Width, 4);
    SourceFile.Position := 84; //FOURCC
    SourceFile.Read(Temp, 4); // Store the FOURCC for later
    SourceFile.Position := 128; //End of the dds header

    //Correct for big endian
    if BigEndian then Width := SwapEndianDWord(Width);
    if BigEndian then Height := SwapEndianDWord(Height);

    NewDestDir :=  IncludeTrailingPathDelimiter(DestDir) + ExtractPartialPath( FileName, SourceDir);
    ForceDirectories( NewDestDir );

    DestFile := TFileStream.Create(
                  IncludeTrailingPathDelimiter(NewDestDir) +
                  ChangeFileExt( ExtractFileName( FileName ), '.dxt') ,
                  fmCreate);
    try
      DestFile.Write(Temp, SizeOf(Temp)); //FOURCC eg DXT5
      Temp := Width;
      DestFile.Write(Temp, SizeOf(Temp));
      Temp := Height;
      DestFile.Write(Temp, SizeOf(Temp));

      //GZip the data
      GZCompressStream(SourceFile, DestFile, '', '', 0);

      if DestFile.Size > 12 then result := true;
    finally
      DestFile.Free;
    }

  finally
    SourceFile.Free;
  }
}

function DateTimeToUnix(const AValue: TDateTime): Cardinal;
{
  Result := Round((AValue - UnixDateDelta) * SecsPerDay);
}

//Mostly same as usual procedure in ZLibExGZ unit except parameters changed for MI2-SE
procedure GZCompressStream(inStream, outStream: TStream; const fileName,
  comment: AnsiString; dateTime: TDateTime);
const
  bufferSize = 32768;
  GZ_ZLIB_WINDOWBITS = -8;
  GZ_ZLIB_MEMLEVEL   = 1;

  GZ_ASCII_TEXT  = $01;
  GZ_HEADER_CRC  = $02;
  GZ_EXTRA_FIELD = $04;
  GZ_FILENAME    = $08;
  GZ_COMMENT     = $10;
  GZ_RESERVED    = $E0;

  GZ_EXTRA_DEFAULT = 0;
  GZ_EXTRA_MAX     = 2;
  GZ_EXTRA_FASTEST = 4;

  SGZInvalid = 'Invalid GZStream operation!';
var
  header    : TGZHeader;
  trailer   : TGZTrailer;
  buffer    : Array [0..bufferSize-1] of Byte;
  count     : Integer;
  position  : TStreamPos;
  nullString: AnsiString;
{
  FillChar(header,SizeOf(TGZHeader),0);

  header.Id1 := $1F;
  header.Id2 := $8B;
  header.Method := Z_DEFLATED;

  if dateTime <> 0 then header.Time := DateTimeToUnix(dateTime);

  header.ExtraFlags := GZ_EXTRA_FASTEST;
  header.OS := 0;

  header.Flags := 0;

  if Length(fileName) > 0 then header.Flags := header.Flags or GZ_FILENAME;
  if Length(comment) > 0 then header.Flags := header.Flags or GZ_COMMENT;

  FillChar(trailer, SizeOf(TGZTrailer), 0);

  trailer.Crc := 0;

  position := inStream.Position;

  while inStream.Position < inStream.Size do
  {
    count := inStream.Read(buffer[0],bufferSize);

    trailer.Crc := ZCrc32(trailer.Crc,buffer[0],count);
  }

  inStream.Position := position;

  trailer.Size := inStream.Size - inStream.Position;

  outStream.Write(header, SizeOf(TGZHeader));

  if Length(filename) > 0 then
  {
    nullString := fileName + #$00;

    outStream.Write(nullString[1], Length(nullString));
  }

  if Length(comment) > 0 then
  {
    nullString := comment + #$00;

    outStream.Write(nullString[1], Length(nullString));
  }

  ZCompressStream2(inStream, outStream, zcFastest, GZ_ZLIB_WINDOWBITS,
    GZ_ZLIB_MEMLEVEL, zsDefault);

  outStream.Write(trailer, SizeOf(TGZTrailer));
}
