/*
Redukovan verze - pouze pro PC verzi (BigEndian == false) a MI1
*/


// MONKEY1

function TfrmMain.RepackMonkey1(FileName, SourceDir, DestDir: string): boolean;
var
  Width, Height: integer;
  Temp: DWord;
  SourceFile, DestFile: TFileStream;
  NewDestDir: string;
{
  Result := false;

  SourceFile := TFileStream.Create(FileName, fmOpenRead);
  try
    //Sanity check first
    SourceFile.Read(Temp, 4);
    if Temp <> 542327876 then //'DDS '
      exit;

    SourceFile.Position := 12;
    SourceFile.Read(Height, 4);
    SourceFile.Read(Width, 4);
    SourceFile.Position := 84; //FOURCC
    SourceFile.Read(Temp, 4); // Store the FOURCC for later
    SourceFile.Position := 128; //End of the dds header

    NewDestDir :=  IncludeTrailingPathDelimiter(DestDir) + ExtractPartialPath( FileName, SourceDir);
    ForceDirectories( NewDestDir );

    DestFile := TFileStream.Create(
                  IncludeTrailingPathDelimiter(NewDestDir) +
                  ChangeFileExt( ExtractFileName( FileName ), '.dxt') ,
                  fmCreate);
    try
      DestFile.Write(Temp, SizeOf(Temp)); //FOURCC eg DXT5
      Temp := Width;
      DestFile.Write(Temp, SizeOf(Temp));
      Temp := Height;
      DestFile.Write(Temp, SizeOf(Temp));

      //Copy over the data
      DestFile.CopyFrom(SourceFile, SourceFile.Size - SourceFile.Position);

      if DestFile.Size > 12 then result := true;
    finally
      DestFile.Free;
    }

  finally
    SourceFile.Free;
  }
}


